-- name: Super Mario Galaxy Luigi Voice
-- incompatible:
-- description:Makes Luigi sound like his Super Luigi Galaxy Version.\nLua by \\#ff6b91\\SMS Alfredo\\#ffffff\\\n

--Define what triggers the custom voice
local function use_custom_voice(m)
    return m.character.type == CT_LUIGI --Put your condition here!
end

--How many snores the sleep-talk has, or rather, how long the sleep-talk lasts
--If you omit the sleep-talk you can ignore this
local SLEEP_TALK_SNORES = 8

--Define what actions play what voice clips
--If an action has more than one voice clip, put those clips inside a table
--CHAR_SOUND_SNORING3 requires two or three voice clips to work properly...
--but you can omit it if your character does not sleep-talk
local CUSTOM_VOICETABLE = {
    [CHAR_SOUND_ATTACKED] = {'vc luigi pain.ogg', 'vc luigi pain2.ogg', 'vc luigi pain3.ogg'},
    [CHAR_SOUND_COUGHING1] = 'vc luigi Cough.ogg',
    [CHAR_SOUND_COUGHING2] = 'vc luigi Cough2.ogg',
    [CHAR_SOUND_COUGHING3] = 'vc luigi Cough3.ogg',
    [CHAR_SOUND_DOH] = {'vc luigi Bonk.ogg', 'vc luigi Bonk2.ogg', 'vc luigi Bonk3.ogg'},
    [CHAR_SOUND_DROWNING] = {'vc luigi Drowned.ogg', 'vc luigi Drowned2.ogg'},
    [CHAR_SOUND_DYING] = {'vc luigi Dead.ogg', 'vc luigi Dead2.ogg', 'vc luigi Dead3.ogg'},
    [CHAR_SOUND_EEUH] = {'vc luigi Ledge Pull.ogg', 'vc luigi Ledge Pull2.ogg', 'vc luigi Ledge Pull3.ogg', 'vc luigi Ledge Pull4.ogg', 'vc luigi Ledge Pull5.ogg', 'vc luigi Ledge Pull6.ogg', 'vc luigi Ledge Pull7.ogg'},
    [CHAR_SOUND_GAME_OVER] = 'vc luigi Blackholedeath2.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = {'vc luigi GP.ogg', 'vc luigi GP2.ogg', 'vc luigi GP3.ogg'},
    [CHAR_SOUND_HAHA] = 'vc luigi Haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'vc luigi Luigiii.ogg',
    [CHAR_SOUND_HELLO] = 'vc luigi Heeey.ogg',
    [CHAR_SOUND_HERE_WE_GO] = {'vc luigi Oh ye.ogg', 'vc luigi STAAAR.ogg', 'vc luigi Wahoooooooh.ogg', 'vc luigi Yahaaaa.ogg', 'vc luigi look at me luigi.ogg'},
    [CHAR_SOUND_HOOHOO] = {'vc luigi Jump4.ogg', 'vc luigi Jump5.ogg', 'vc luigi Jump6.ogg', 'vc luigi Jump7.ogg'},
    [CHAR_SOUND_HRMM] = {'vc luigi Pick up.ogg', 'vc luigi Pick up2.ogg'},
    [CHAR_SOUND_IMA_TIRED] = 'vc luigi Sigh.ogg',
    [CHAR_SOUND_LETS_A_GO] = {'vc luigi letse gooo.ogg', 'vc luigi Launch Star.ogg'},
    [CHAR_SOUND_MAMA_MIA] = 'vc luigi Owch.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'vc luigi Oh ye2.ogg',
    [CHAR_SOUND_ON_FIRE] = {'vc luigi Burn.ogg', 'vc luigi Burn2.ogg', 'vc luigi Burn3.ogg'},
    [CHAR_SOUND_OOOF] = {'vc luigi Heavy Damage.ogg', 'vc luigi Heavy Damage2.ogg', 'vc luigi Heavy Damage3.ogg', 'vc luigi Heavy Damage4.ogg'},
    [CHAR_SOUND_OOOF2] = {'vc luigi Heavy DamageC.ogg', 'vc luigi Heavy Damage2C.ogg', 'vc luigi Heavy Damage3C.ogg', 'vc luigi Heavy Damage4C.ogg'},
    [CHAR_SOUND_PANTING] = 'vc luigi Sigh2.ogg',
    [CHAR_SOUND_PANTING_COLD] = {'vc luigi Sneeze.ogg', 'vc luigi Cold.ogg', 'vc luigi Cold2.ogg', 'vc luigi Cold3.ogg', 'vc luigi Cold4.ogg'},
    [CHAR_SOUND_PRESS_START_TO_PLAY] = 'vc luigi hah heh.ogg',
    [CHAR_SOUND_PUNCH_HOO] = {'vc luigi Attack6.ogg', 'vc luigi Attack7.ogg', 'vc luigi Kick.ogg', 'vc luigi Kick2.ogg'},
    [CHAR_SOUND_PUNCH_WAH] = {'vc luigi Attack4.ogg', 'vc luigi Attack5.ogg'},
    [CHAR_SOUND_PUNCH_YAH] = {'vc luigi Attack.ogg', 'vc luigi Attack2.ogg', 'vc luigi Attack3.ogg'},
    [CHAR_SOUND_SNORING1] = 'vc luigi snore1.ogg',
    [CHAR_SOUND_SNORING2] = 'vc luigi snore2.ogg',
    [CHAR_SOUND_SNORING3] = {'vc luigi snore1C.ogg', 'vc luigi snore2C.ogg', 'vc luigi Blackholedeath3.ogg'},
    [CHAR_SOUND_SO_LONGA_BOWSER] = {'vc luigi Throw4.ogg', 'vc luigi Throw5.ogg', 'vc luigi Throw6.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = {'vc luigi Spin.ogg', 'vc luigi Spin2.ogg', 'vc luigi Spin3.ogg', 'vc luigi Spin NPC.ogg'},
    [CHAR_SOUND_UH] = 'vc luigi BonkC.ogg',
    [CHAR_SOUND_UH2] = 'vc luigi Jump3.ogg',
    [CHAR_SOUND_UH2_2] = 'vc luigi Bonk2C.ogg',
    [CHAR_SOUND_WAAAOOOW] = {'vc luigi Zapped.ogg', 'vc luigi Long Sigh.ogg', 'vc luigi Failsafe grab.ogg', 'vc luigi Blackholedeath.ogg'},
    [CHAR_SOUND_WAH2] = 'vc luigi Jump4C.ogg',
    [CHAR_SOUND_WHOA] = {'vc luigi Ledge Grab.ogg', 'vc luigi Ledge Grab2.ogg', 'vc luigi Ledge Grab3.ogg'},
    [CHAR_SOUND_YAHOO] = {'vc luigi SidejumpC.ogg', 'vc luigi Sidejump2C.ogg', 'vc luigi Sidejump3C.ogg'},
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'vc luigi Longjump.ogg', 'vc luigi Longjump2.ogg', 'vc luigi Longjump3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'vc luigi Jump.ogg', 'vc luigi Jump2.ogg', 'vc luigi Jump7C.ogg', 'vc luigi Jump5C.ogg', 'vc luigi Jump6C.ogg'},
    [CHAR_SOUND_YAWNING] = {'vc luigi yawn.ogg', 'vc luigi Yawn long.ogg'},
}

--Define the table of samples that will be used for each player
--Global so if multiple mods use this they won't create unneeded samples
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
gCustomVoiceSamples = {}
gCustomVoiceStream = nil

--Get the player's sample, stop whatever sound
--it's playing if it doesn't match the provided sound
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
--- @param m MarioState
function stop_custom_character_sound(m, sound)
    local voice_sample = gCustomVoiceSamples[m.playerIndex]
    if voice_sample == nil or not voice_sample.loaded then
        return
    end

    audio_sample_stop(voice_sample)
    if voice_sample.file.relativePath:match('^.+/(.+)$') == sound then
        return voice_sample
    end
    audio_sample_destroy(voice_sample)
end

--Play a custom character's sound
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
--- @param m MarioState
function play_custom_character_sound(m, voice)
    --Get sound, if it's a table, get a random entry from it
    local sound
    if type(voice) == "table" then
        sound = voice[math.random(#voice)]
    else
        sound = voice
    end
    if sound == nil then return 0 end

    --Get current sample and stop it
    local voice_sample = stop_custom_character_sound(m, sound)

    --If the new sound isn't a string, let's assume it's
    --a number to return to the character sound hook
    if type(sound) ~= "string" then
        return sound
    end

    --Load a new sample and play it! Don't make a new one if we don't need to
    if (m.area == nil or m.area.camera == nil) and m.playerIndex == 0 then
        if gCustomVoiceStream ~= nil then
            audio_stream_stop(gCustomVoiceStream)
            audio_stream_destroy(gCustomVoiceStream)
        end
        gCustomVoiceStream = audio_stream_load(sound)
        audio_stream_play(gCustomVoiceStream, true, 1)
    else
        if voice_sample == nil then
            voice_sample = audio_sample_load(sound)
        end
        audio_sample_play(voice_sample, m.pos, 1)

        gCustomVoiceSamples[m.playerIndex] = voice_sample
    end
    return 0
end

--Main character sound hook
--This hook is freely modifiable in case you want to make any specific exceptions
--- @param m MarioState
local function custom_character_sound(m, characterSound)
    if not use_custom_voice(m) then return end
    if characterSound == CHAR_SOUND_SNORING3 then return 0 end
    if characterSound == CHAR_SOUND_HAHA and m.hurtCounter > 0 then return 0 end

    local voice = CUSTOM_VOICETABLE[characterSound]
    if voice ~= nil then
        return play_custom_character_sound(m, voice)
    end
    return 0
end
hook_event(HOOK_CHARACTER_SOUND, custom_character_sound)

--Snoring logic for CHAR_SOUND_SNORING3 since we have to loop it manually
--This code won't activate on the Japanese version, due to MARIO_MARIO_SOUND_PLAYED not being set
local SNORE3_TABLE = CUSTOM_VOICETABLE[CHAR_SOUND_SNORING3]
local STARTING_SNORE = 46
local SLEEP_TALK_START = STARTING_SNORE + 49
local SLEEP_TALK_END = SLEEP_TALK_START + SLEEP_TALK_SNORES

--Main hook for snoring
--- @param m MarioState
local function custom_character_snore(m)
    if not use_custom_voice(m) then return end

    --Stop the snoring!
    if m.action ~= ACT_SLEEPING then
        if m.isSnoring > 0 then
            stop_custom_character_sound(m)
        end
        return

    --You're not in deep snoring
    elseif not (m.actionState == 2 and (m.flags & MARIO_MARIO_SOUND_PLAYED) ~= 0) then
        return
    end

    local animFrame = m.marioObj.header.gfx.animInfo.animFrame

    --Behavior for CHAR_SOUND_SNORING3
    if SNORE3_TABLE ~= nil and #SNORE3_TABLE >= 2 then
        --Exhale sound
        if animFrame == 2 and m.actionTimer < SLEEP_TALK_START then
            play_custom_character_sound(m, SNORE3_TABLE[2])

        --Inhale sound
        elseif animFrame == 25 then
            
            --Count up snores
            if #SNORE3_TABLE >= 3 then
                m.actionTimer = m.actionTimer + 1

                --End sleep-talk
                if m.actionTimer >= SLEEP_TALK_END then
                    m.actionTimer = STARTING_SNORE
                end
    
                --Enough snores? Start sleep-talk
                if m.actionTimer == SLEEP_TALK_START then
                    play_custom_character_sound(m, SNORE3_TABLE[3])
                
                --Regular snoring
                elseif m.actionTimer < SLEEP_TALK_START then
                    play_custom_character_sound(m, SNORE3_TABLE[1])
                end
            
            --Definitely regular snoring
            else
                play_custom_character_sound(m, SNORE3_TABLE[1])
            end
        end

    --No CHAR_SOUND_SNORING3, just use regular snoring
    elseif animFrame == 2 then
        play_character_sound(m, CHAR_SOUND_SNORING2)

    elseif animFrame == 25 then
        play_character_sound(m, CHAR_SOUND_SNORING1)
    end
end
hook_event(HOOK_MARIO_UPDATE, custom_character_snore)